package com.jasamedika.medifirst2000.vo;

import java.io.Serializable;
import javax.persistence.*;
import java.util.Date;
import org.hibernate.validator.constraints.NotEmpty;

import com.jasamedika.medifirst2000.base.vo.BaseMasterVO;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.internal.util.logging.Messages;

import com.fasterxml.jackson.annotation.JsonManagedReference;
import com.jasamedika.medifirst2000.base.vo.BaseMasterVO;
import com.jasamedika.medifirst2000.helper.Caption;

/**
 *  class PersenTanggunganPenjamin
 * 
 * @author Generator
 */
//@Entity
//@Table(name = "PersenTanggunganPenjamin_M")
public class PersenTanggunganPenjaminVO extends BaseMasterVO {
	@Caption(value="Is Paket")
	private Byte isPaket;

	public void setIsPaket(Byte isPaket) {
		this.isPaket = isPaket;
	}

	@Column(name = "isPaket", nullable = false )
	public Byte getIsPaket(){
		return this.isPaket;
	}

	@ManyToOne
	@JoinColumn(name = "ObjectAsalProdukFk")
	@NotNull(message="Object Asal ProdukVO Harus Diisi")
	@Caption(value="Object Asal Produk")
	private AsalProdukVO asalProduk;

	public void setAsalProduk(AsalProdukVO asalProduk) {
		this.asalProduk = asalProduk;
	}

	@Column(name = "KdAsalProduk", nullable = false )
	public AsalProdukVO getAsalProduk(){
		return this.asalProduk;
	}

	@Column(name = "ObjectAsalProdukFk", insertable=false,updatable=false)
	private Integer asalProdukId;

	@ManyToOne
	@JoinColumn(name = "ObjectGolonganAsuransiFk")
	@NotNull(message="Object Golongan Asuransi Harus Diisi")
	@Caption(value="Object Golongan Asuransi")
	private GolonganAsuransiVO kdGolonganAsuransi;

	public void setGolonganAsuransi(GolonganAsuransiVO kdGolonganAsuransi) {
		this.kdGolonganAsuransi = kdGolonganAsuransi;
	}

	@Column(name = "KdGolonganAsuransi", nullable = false )
	public GolonganAsuransiVO getGolonganAsuransi(){
		return this.kdGolonganAsuransi;
	}

	@Column(name = "ObjectGolonganAsuransiFk", insertable=false,updatable=false)
	private Integer golonganAsuransiId;

	@ManyToOne
	@JoinColumn(name = "ObjectHubunganPesertaFk")
	@NotNull(message="Object Hubungan Peserta Harus Diisi")
	@Caption(value="Object Hubungan Peserta")
	private HubunganPesertaAsuransiVO hubunganPeserta;

	public void setHubunganPeserta(HubunganPesertaAsuransiVO hubunganPeserta) {
		this.hubunganPeserta = hubunganPeserta;
	}

	@Column(name = "KdHubunganPeserta", nullable = false )
	public HubunganPesertaAsuransiVO getHubunganPeserta(){
		return this.hubunganPeserta;
	}

	@Column(name = "ObjectHubunganPesertaFk", insertable=false,updatable=false)
	private Integer hubunganPesertaId;

	@ManyToOne
	@JoinColumn(name = "ObjectJenisTransaksiFk")
	@NotNull(message="Object Jenis Transaksi Harus Diisi")
	@Caption(value="Object Jenis Transaksi")
	private JenisTransaksiVO jenisTransaksi;

	public void setJenisTransaksi(JenisTransaksiVO jenisTransaksi) {
		this.jenisTransaksi = jenisTransaksi;
	}

	@Column(name = "KdJenisTransaksi", nullable = false )
	public JenisTransaksiVO getJenisTransaksi(){
		return this.jenisTransaksi;
	}

	@Column(name = "ObjectJenisTransaksiFk", insertable=false,updatable=false)
	private Integer jenisTransaksiId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelasFk")
	@NotNull(message="Object KelasVO Harus Diisi")
	@Caption(value="Object Kelas")
	private DetailKamarVO kelas;

	public void setKelas(DetailKamarVO kelas) {
		this.kelas = kelas;
	}

	@Column(name = "KdKelas", nullable = false , length = 2)
	public DetailKamarVO getKelas(){
		return this.kelas;
	}

	@Column(name = "ObjectKelasFk", insertable=false,updatable=false)
	private Integer kelasId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelasSelisihBerlakuFk")
	@Caption(value="Object KelasVO Selisih Berlaku")
	private DetailKamarVO kelasSelisihBerlaku;

	public void setKelasSelisihBerlaku(DetailKamarVO kelasSelisihBerlaku) {
		this.kelasSelisihBerlaku = kelasSelisihBerlaku;
	}

	@Column(name = "KdKelasSelisihBerlaku", nullable = true , length = 2)
	public DetailKamarVO getKelasSelisihBerlaku(){
		return this.kelasSelisihBerlaku;
	}

	@Column(name = "ObjectKelasSelisihBerlakuFk", insertable=false,updatable=false)
	private Integer kelasSelisihBerlakuId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelompokPasienFk")
	@NotNull(message="Object Kelompok PasienVO Harus Diisi")
	@Caption(value="Object Kelompok Pasien")
	private KelompokPasienVO kelompokPasien;

	public void setKelompokPasien(KelompokPasienVO kelompokPasien) {
		this.kelompokPasien = kelompokPasien;
	}

	@Column(name = "KdKelompokPasien", nullable = false )
	public KelompokPasienVO getKelompokPasien(){
		return this.kelompokPasien;
	}

	@Column(name = "ObjectKelompokPasienFk", insertable=false,updatable=false)
	private Integer kelompokPasienId;

	@Caption(value="Kode Penjamin Pasien")
	private short kdPenjaminPasien;

	public void setKdPenjaminPasien(short kdPenjaminPasien) {
		this.kdPenjaminPasien = kdPenjaminPasien;
	}

	@Column(name = "KdPenjaminPasien", nullable = false )
	public short getKdPenjaminPasien(){
		return this.kdPenjaminPasien;
	}

	@Caption(value="Max T Penjamin")
	private Double maxTPenjamin;

	public void setMaxTPenjamin(Double maxTPenjamin) {
		this.maxTPenjamin = maxTPenjamin;
	}

	@Column(name = "MaxTPenjamin", nullable = true )
	public Double getMaxTPenjamin(){
		return this.maxTPenjamin;
	}

	@Caption(value="Max T Penjamin All")
	private Double maxTPenjaminAll;

	public void setMaxTPenjaminAll(Double maxTPenjaminAll) {
		this.maxTPenjaminAll = maxTPenjaminAll;
	}

	@Column(name = "MaxTPenjaminAll", nullable = true )
	public Double getMaxTPenjaminAll(){
		return this.maxTPenjaminAll;
	}

	@Caption(value="No Urut KelasVO Selisih Berlaku")
	private Byte noUrutKelasSelisihBerlaku;

	public void setNoUrutKelasSelisihBerlaku(Byte noUrutKelasSelisihBerlaku) {
		this.noUrutKelasSelisihBerlaku = noUrutKelasSelisihBerlaku;
	}

	@Column(name = "NoUrutKelasSelisihBerlaku", nullable = true )
	public Byte getNoUrutKelasSelisihBerlaku(){
		return this.noUrutKelasSelisihBerlaku;
	}

	@Caption(value="Persen Discount")
	private Double persenDiscount;

	public void setPersenDiscount(Double persenDiscount) {
		this.persenDiscount = persenDiscount;
	}

	@Column(name = "PersenDiscount", nullable = false )
	public Double getPersenDiscount(){
		return this.persenDiscount;
	}

	@Caption(value="Persen T Penjamin")
	private Double persenTPenjamin;

	public void setPersenTPenjamin(Double persenTPenjamin) {
		this.persenTPenjamin = persenTPenjamin;
	}

	@Column(name = "PersenTPenjamin", nullable = false )
	public Double getPersenTPenjamin(){
		return this.persenTPenjamin;
	}

	@Caption(value="Persen T Penjamindr Selisih")
	private Double persenTPenjamindrSelisih;

	public void setPersenTPenjamindrSelisih(Double persenTPenjamindrSelisih) {
		this.persenTPenjamindrSelisih = persenTPenjamindrSelisih;
	}

	@Column(name = "PersenTPenjamindrSelisih", nullable = false )
	public Double getPersenTPenjamindrSelisih(){
		return this.persenTPenjamindrSelisih;
	}

	@Caption(value="Persen T Profile")
	private Double persenTProfile;

	public void setPersenTProfile(Double persenTProfile) {
		this.persenTProfile = persenTProfile;
	}

	@Column(name = "PersenTProfile", nullable = false )
	public Double getPersenTProfile(){
		return this.persenTProfile;
	}

	@Caption(value="Persen T Profiledr Selisih")
	private Double persenTProfiledrSelisih;

	public void setPersenTProfiledrSelisih(Double persenTProfiledrSelisih) {
		this.persenTProfiledrSelisih = persenTProfiledrSelisih;
	}

	@Column(name = "PersenTProfiledrSelisih", nullable = false )
	public Double getPersenTProfiledrSelisih(){
		return this.persenTProfiledrSelisih;
	}

	@Caption(value="Qty Max Kunjungan")
	private short qtyMaxKunjungan;

	public void setqtyMaxKunjungan(short qtyMaxKunjungan) {
		this.qtyMaxKunjungan = qtyMaxKunjungan;
	}

	@Column(name = "QtyMaxKunjungan", nullable = false )
	public short getqtyMaxKunjungan(){
		return this.qtyMaxKunjungan;
	}

	@Caption(value="Tanggal Berlaku Akhir")
	private Date tglBerlakuAkhir;

	public void setTglBerlakuAkhir(Date tglBerlakuAkhir) {
		this.tglBerlakuAkhir = tglBerlakuAkhir;
	}

	@Column(name = "TglBerlakuAkhir", nullable = true )
	public Date getTglBerlakuAkhir(){
		return this.tglBerlakuAkhir;
	}

	@Caption(value="Tanggal Berlaku Awal")
	private Date tglBerlakuAwal;

	public void setTglBerlakuAwal(Date tglBerlakuAwal) {
		this.tglBerlakuAwal = tglBerlakuAwal;
	}

	@Column(name = "TglBerlakuAwal", nullable = false )
	public Date getTglBerlakuAwal(){
		return this.tglBerlakuAwal;
	}


}

